<?php
defined('_JEXEC') or die;

use LMS\Tools\Courses\Helpers;

class ModJlmsCourseTeacherHelper
{
	public static function getTeacherInformation($params)
	{
		$app = JFactory::getApplication();
		$db = JFactory::getDbo();

		if($app->input->getCmd('option') == 'com_joomla_lms'){
			$pathToLms = JPATH_SITE . '/components/com_joomla_lms';
			require_once ($pathToLms . '/libraries/servicelocator.php');

			require_once ($pathToLms . '/includes/lms_legacy.php');
			require_once ($pathToLms . '/joomla_lms.main.php');
			require_once ($pathToLms . '/includes/libraries/lms.lib.language.php');

			\LMS\Libraries\ServiceLocator::registerNamespace('LMS', $pathToLms);
			\LMS\Libraries\ServiceLocator::activate();

			\LMS\Libraries\ServiceLocator::load('lib.base');

			$jlmsConfig = \LMS\Libraries\ServiceLocator::get('config');

			$courseId = $jlmsConfig->get('course_id', 0);
			if($courseId){
				$query = "SELECT b.name, b.email, c.*"
					. "\n FROM #__lms_courses as a"
					. "\n LEFT JOIN #__users as b ON a.owner_id = b.id"
					. "\n LEFT JOIN #__lms_courses_ownerinfo as c ON a.id = c.course_id AND a.owner_id = c.owner_id"
					. "\n WHERE 1"
					. "\n AND a.id = ".$db->quote($courseId)
				;
				$db->setQuery($query);
				$ownerInformation = $db->loadObject();

				if(isset($ownerInformation->id) && $ownerInformation->id && $ownerInformation->file_photo){
					if(file_exists(Helpers\Avatar::filePath($ownerInformation->file_photo, $type = 'large'))){
						$ownerInformation->file_photo = Helpers\Avatar::getAvatar($ownerInformation->file_photo);
					} else {
						$ownerInformation->file_photo = null;
					}
				}

				if(!$ownerInformation->fullname){
					$ownerInformation->fullname = $ownerInformation->name;
				}

				return $ownerInformation;
			}
		}
	}
}