var Jlms = Jlms||{};

Jlms.Storage = function(name){	
	this.data = {};
	this.name = name;
	this.debug = false;			

	this.log = function(action, state, value, ext){				
		if(this.debug) {
			var a = {};			
			a.name = name;
			a.action = action;
			a.state = state;
			a.data = this.data;
			a.value = value;
			
			if(typeof(ext) !== 'undefined') {
				a.ext = ext;				
			}
			
			console.log(a);
		}				
	};
	
	this.getExtData = function(state, ext) {
		return this.getData(state, ext, true);
	};
	
	this.getData = function(state, ext, includeExtDataInResponse) {		
		var res = [];		
		if(typeof ext === 'object') {
			for(var i=0; i<ext.length; i++) {
				res = res.concat(this._getData(state, ext[i], includeExtDataInResponse));
			}			
			return res;
		} else {
			res = this._getData(state, ext, includeExtDataInResponse);			
			return res;
		}	
	};
	
	this._getData = function(state, ext, includeExtDataInResponse) {	
		if(typeof(state) === 'undefined') {
			this.log('get', state, [], ext);
			return [];
		}				
		
		if(state in this.data) {
			return this.data[state];
		} else {
			var res = includeExtDataInResponse?{}:[],
				data = this.data;		
			
			if(typeof ext !== 'undefined' ) {
				data = {};
				data[ext] = this.data[ext];
			}
			
			for (var ext in data) {
				if(!(state in data[ext])) {
					continue;
				} else {					
					if(includeExtDataInResponse) {
						for(var i=0; i<data[ext][state].length; i++) {							
							res[data[ext][state][i]] = [ext];								
						}						
					} else {						
						res = res.concat(data[ext][state]);
					}					
				}
				
			}		
			
			this.log('get', state, res, ext);
			return res;
		}		
	};
	
	this.setData = function(state, value, ext) {		
		if(typeof ext === 'object') {
			ext = ext[0];
		}
		
		if(typeof value === 'object') {			
			for(var i=0; i<value.length; i++) {
				this._setData(state, value[i], ext);
			}			
		} else {			
			this._setData(state, value, ext);
		}		
	}

	this._setData = function(state, value, ext) {		
		if(typeof(ext) === 'undefined') {			
			if(!(state in this.data)) {
				this.data[state] = [];
			}
			if(this.data[state].indexOf(value) >= 0) {
				return true;
			}					
			this.data[state].push(value);
		} else {					
			if(!(ext in this.data)) {
				this.data[ext] = {};
			}					
			if(!(state in this.data[ext])) {
				this.data[ext][state] = [];
			}
			if(this.data[ext][state].indexOf(value) >= 0) {
				return true;
			}								
			this.data[ext][state].push(value);			
		}			
		
		this.log('set', state, value, ext);		
	};
	
	this.cleanExtData = function(state, ext) {
		if(typeof ext === 'object') {
			for(var i=0; i<ext.length; i++) {
				this._cleanExtData(state, ext[i]);
			}
		} else {
			this._cleanExtData(state, ext);
		}
	}
	
	this._cleanExtData = function(state, ext) {
		if(typeof ext === 'undefined') {
			return this.removeData(state);
		} else {
			return this.removeData(state, null, ext);
		}
	};
	
	this.removeData = function(state, value, ext) {		
		if(value && typeof value === 'object') {
			for(var i=0; i<value.length; i++) {
				if(typeof ext === 'object') {
					for(var j=0; j<ext.length; j++) {
						this._removeData(state, value[i], ext[j]);
					}
				} else {
					this._removeData(state, value[i], ext);
				}
			}
		} else {			
			if(typeof ext === 'object') {				
				for(var i=0; i<ext.length; i++) {
					this._removeData(state, value, ext[i]);
				}
			} else {				
				this._removeData(state, value, ext);
			}			
		}			
	}

	this._removeData = function(state, value, ext) {
		this.log('remove', state, value, ext);
				
		if(typeof(state) === 'undefined') {
			return false;
		}
		
		if(typeof ext !== 'undefined') {
			if(typeof this.data[ext] === 'undefined') {
				return true;
			}
			
			if(!value) {			
				this.data[ext][state] = [];
				return true;
			}
		}		
		
		if(typeof value === 'undefined' && typeof ext === 'undefined') {		
			if(state in this.data) {				
				this.data[state] = [];
			} else {				
				for(_ext in this.data) {						
					this.data[_ext][state] = [];					
				}			
			}			
			return true;
		}					
		
		var	items = this.getData(state, ext),
			index = items.indexOf(value);
		
		if(index !== -1) {
			if(typeof(ext) === 'undefined') {					
				this.data[state].splice(index, 1);						
			} else {					
				this.data[ext][state].splice(index, 1);					
			}
		}			
	};

	this.existsData = function(state, value, ext) {					
		if(typeof(state) === 'undefined' || typeof(value) === 'undefined') {
			this.log('exists', state, false, ext)
			return false;
		}			
		var	items = this.getData(state, ext),
			index = items.indexOf(value),
			res = true;
			
		if(index === -1) {
			res = false;
		}
		this.log('exists', state, res, ext)
		return res;
	};		
}