<?php
/**
 * User: nester_a
 * Date: 09.07.14
 */

namespace LMS\Libraries\Date;

class Handler
{

	public function getUTCDatetime($format = 'Y-m-d H:i:s', $timestamp = null)
	{
		if(is_null($timestamp)){
			$timestamp = time();
		}
		$date = new \DateTime(gmdate('Y-m-d H:i:s', $timestamp), new \DateTimeZone('UTC'));
		return $date->format($format);
	}


	public function getCurrentUTCDatetime($format = 'Y-m-d H:i:s')
	{
		return $this->getUTCDatetime($format, time());
	}





	public function getDatetime($format = 'Y-m-d H:i:s', $timestamp = null)
	{
		if(is_null($timestamp)){
			$timestamp = time();
		}
		$date = new \DateTime(gmdate('Y-m-d H:i:s', $timestamp), new \DateTimeZone('UTC'));
		$date->setTimezone($this->getTimezone());
		return $date->format($format);
	}


	public function getCurrentDatetime($format = 'Y-m-d H:i:s')
	{
		return $this->getDatetime($format, time());
	}




	public function getCurrentTimestamp($timezone = 'UTC')
	{
		return $this->getTimestamp('now', $timezone);
	}

	public function getTimestamp($dateString, $timezone = 'UTC')
	{
		$date = new \DateTime($dateString, new \DateTimeZone($timezone));
		return $date->getTimestamp();
	}




	public function getTimezone()
	{
		$config = \JFactory::getConfig();
		return new \DateTimeZone($config->get('offset'));
	}

	public function getTimezoneName()
	{
		return $this->getTimezone()->getName();
	}


    public function compareTwoDates($firstDate = "now", $secondDate = "now")
    {
        $date1 = new \DateTime($firstDate);
        $date2 = new \DateTime($secondDate);
        $interval = $date1->diff($date2);

        $returnDateData = new \stdClass();
        $returnDateData->type = ($interval->invert?'more':'less');
        $returnDateData->years = $interval->format('%y');
        $returnDateData->months = $interval->format('%m');
        $returnDateData->days   = $interval->format('%d');
        $returnDateData->hours  = $interval->format('%h');
        $returnDateData->minutes = $interval->format('%i');
        $returnDateData->seconds = $interval->format('%s');
        return $returnDateData;
    }

    static function parseTimeReleasedPeriod( $period = 0 )
    {
    $parsed_period = array();

        $ost_first = $period%(24*60);
        $parsed_period['days'] = ($period - $ost_first)/(24*60);
        $ost_second = $period%60;
        $parsed_period['hours'] = ($ost_first - $ost_second)/60;
        $parsed_period['minutes'] = $ost_second;

        return $parsed_period;
    }

}