<?php
/**
 * User: nester_a
 * Date: 22.07.14
 */

namespace LMS\Tests\Data\Tables;

use LMS\Libraries\Base\Table;

class TestTable3 extends Table
{
	public $id;
	public $key_id;
	public $name;
	public $description;

	protected $alias = 'table_3';

	public function __construct($db = false)
	{
		parent::__construct("#__lms_table3", "id", $db);
	}

	protected function initRelations()
	{
		$this->relations = array(
			'child1' => array(
				'table' => new TestTable4($this->getDbo()),
				'type' => 'INNER',
				'condition' => '{parent.key_id} = {child.id}',
				'capacity' => self::MANY
			),
			'child2' => array(
				'table' => new TestTable1($this->getDbo()),
				'type' => 'INNER',
				'condition' => '{parent.key_id} = {child.id}',
				'capacity' => self::MANY
			),
		);
	}
}