<?php
namespace LMS\Tools\Announcements\View;

defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Actual extends Base\View
{
    public function __construct($config = array())
    {
        $this->viewDir = __DIR__;
        parent::__construct($config);
        $this->acl = ServiceLocator::get('acl');

    }

    public function display($tpl = null)
    {
        $tool_path = \Juri::root().'components/com_joomla_lms/tools/announcements';
        $this->addStyleSheet( $tool_path.'/assets/css/announcements.css');

        $model = $this->getModel();
        $model->setState('announcements.featured',0);
        $this->actual_items = $model->getAllActualItems();
        $this->pagination = $model->getPagination();
        $this->toolbar = $this->getToolbar();

        return parent::display($tpl);
    }

    private function getToolbar()
    {
        jimport('cms.html.toolbar');
        $toolbar = new \LMS\Widgets\ContentToolbar();
        if ( $this->acl->CheckPermissions('announce', 'manage') )
        {
            $toolbar->addNewButton( array('href' => 'javascript: Joomla.submitbutton(\'announcements.announcement.add\')') );
        }
        return $toolbar->render();
    }

}