<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 * 
 */

namespace LMS\Tools\Users\Repositories;
 
defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Tools\Users\Tables;
use LMS\Libraries\Servicelocator;
	
class Student extends Base\Repository 
{
	protected $id;
		
	public function __construct($options = array())
	{
		parent::__construct($options);
		$this->table = new Tables\UsersInGroups($this->db);
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{
		$filters = (isset($filterOptions['list.filters']))?$filterOptions['list.filters']:array();
				
		$config = ServiceLocator::get('config');

		if(!$config->get('use_global_groups')){
			$query->where('student.role_id = 2');
		}

		$filters = (isset($filterOptions['list.filters']))?$filterOptions['list.filters']:array();		

		$query->where('student.course_id = '.$this->db->quote($config->get('course_id')));					
		
		if(!empty($filters['search'])) {
			$search = $filters['search'];
			$query->where('
				(
					UPPER(student.profile.username) LIKE UPPER(\'%'.$search.'%\') 
					OR UPPER(student.profile.email) LIKE UPPER(\'%'.$search.'%\') 
					OR UPPER(student.profile.name) LIKE UPPER(\'%'.$search.'%\')
				)'				
			);			
		}
		
		if(isset($filterOptions['user_id']) && empty($filterOptions['user_id'])) {
			$filterOptions['user_id'] = array(-1);
		}
				
		if(isset($filterOptions['user_id'])){				
			if(is_array($filterOptions['user_id'])) {				
				$strUsers = implode(',', $filterOptions['user_id']);				
			} else {
				$strUsers = $filterOptions['user_id'];
			}			
		}
		
		if(isset($filterOptions['group_id']) && empty($filterOptions['group_id'])) {
			$filterOptions['group_id'] = array(-1);
		}
		
		if(isset($filterOptions['group_id'])){
			if(is_array($filterOptions['group_id'])) {
				$strGroups = implode(',', $filterOptions['group_id']);
			} else {
				$strGroups = $filterOptions['group_id'];
			}			
		}	
		
		if(!empty($filterOptions['user_or_group']) && !empty($strUsers) && !empty($strGroups)) {
			$query->where('(student.studentgroup.group_id IN ('.$strGroups.') OR student.user_id IN ('.$strUsers.'))');
		} else {				
			if(!empty($strUsers)) {			
				$query->where('student.user_id IN ('.$strUsers.')');
			}
			
			if(!empty($strGroups)) {
				$query->where('student.studentgroup.group_id IN ('.$strGroups.')');
			}		
		}		
		
		if(!empty($filterOptions['excluded_user_id'])){
			if(is_array($filterOptions['excluded_user_id'])) {
				$strUsers = implode(',', $filterOptions['excluded_user_id']);
			} else {
				$strUsers = $filterOptions['excluded_user_id'];
			}
			
			$query->where('student.user_id NOT IN ('.$strUsers.')');
		}		
		
		if(!empty($filterOptions['excluded_group_id'])){
			if(is_array($filterOptions['excluded_group_id'])) {
				$strUsers = implode(',', $filterOptions['excluded_group_id']);
			} else {
				$strUsers = $filterOptions['excluded_group_id'];
			}
			
			$query->where('student.studentgroup.group_id NOT IN ('.$strUsers.')');
		}		

		$query->where("
		(
			(student.publish_start = 0 AND student.publish_end = 0)
			OR
			(student.publish_start = 1 AND student.start_date <= ".date('Y-m-d')." AND 
			 student.publish_end = 1 AND student.end_date >= ".date('Y-m-d').") 
			OR 
			(student.publish_end = 0 AND student.publish_start = 1 AND student.start_date >= ".date('Y-m-d').")
			OR 
			(student.publish_start = 0 AND student.publish_end = 1 AND student.end_date >= ".date('Y-m-d').")
		)
		");

		if(!empty($filterOptions['homeworkStatus'])){
			if($filterOptions['homeworkStatus'] == 1){
				$query->where('student.homework_results.id IS NOT NULL');
			}
			if($filterOptions['homeworkStatus'] == 2){
				$query->where('student.homework_results.id IS NULL');
			}
			$query->group('student.user_id');
		}
		
		return parent::prepareFilter($query, $filterOptions);
	}	
}
?>